require 'cgi'
require 'cgi/session'

# module Suzaku start
module Suzaku

class Weblib

	# ---------------------------------------------------
	# エラーメッセージ出力 (eruby / mod_ruby) 
	# ---------------------------------------------------

	def error_exit(title, errmsg, link, linkmsg, color="#CC0000")
	  cgi = CGI.new
	  $>.cancel
	  ERuby.noheader = true
	  print cgi.header("type" => "text/html", "charset" => "utf-8")
	  print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head><title>#{title}</title></head>
<body>
  <center>
    <font color=\"#{color}\"><b>--- #{errmsg} ---</b></font>
    <br>
    <br>
    <a href=\"#{link}\">#{linkmsg}</a>
  </center>
</body>
</html>
EOF
	  exit
	end

	# ---------------------------------------------------
	# リストのヘッダー表示 
	# ---------------------------------------------------

	def list_header(url, pos, limit, stotal, query=nil)

	  # query が指定されていない場合
	  if query == nil
	    query = ""
	  end
	  
	  # 「前のページ」の表示
	  if pos - limit > 0
	    print "<a href=\"#{url}?pos=#{pos - limit}#{query}\">前のページ</a>&nbsp;\n"
	  end
	  
	  # 「次のページ」の表示
	  if pos + limit <= stotal
	    print "<a href=\"#{url}?pos=#{pos + limit}#{query}\">次のページ</a>&nbsp;\n"
	  end
	end

	# ---------------------------------------------------
	# リストのフッダー表示 
	# ---------------------------------------------------

	def list_fooder(url, pos, limit, stotal, max_page, list_name=nil, query=nil)

	  # query が指定されていない場合
	  if query == nil
	    query = ""
	  end
	  
	  # リスト名の表示
	  if list_name == nil
	    list_name = "Result"
	  end
	  print "#{list_name}:&nbsp;"

	  # 各ページへのリンクの表示
	  pos_s = ((pos / (limit * max_page.to_f)).floor) * (limit * max_page) + 1
	  pn = (pos_s - 1) / limit + 1

	  pos_b = pos_s - (limit * max_page)
	  if pos_b < 1
	    pos_b = 1
	  end

	  pos_n = pos_s + (limit * max_page)
	  
	  # 前リストへのリンクの表示
	  if pn > 1
	    print "<a href=\"#{url}?pos=#{pos_b}#{query}\">&lt;&lt;</a>&nbsp;&nbsp;\n"
	  end
	  
	  # 各ページへのリンクの表示
	  (1..max_page).each do |ctr|
	    print "<a href=\"#{url}?pos=#{pos_s}#{query}\">#{pn + ctr - 1}</a>&nbsp;\n"
	    pos_s += limit
	    if pos_s > stotal
	      break
	    end
	  end
	 
	  # 後リストへのリンクの表示
	  if pos_s < stotal
	    print "<a href=\"#{url}?pos=#{pos_n}#{query}\">&gt;&gt;</a>&nbsp;&nbsp;\n"
	  # print "more..\n"
	  end
	end

	# ---------------------------------------------------
	# デバッグ出力 (eruby / mod_ruby) 
	# ---------------------------------------------------

	def debug(e1, e2=nil, e3=nil, e4=nil, e5=nil, e6=nil)
	  cgi = CGI.new
	  $>.cancel
	  ERuby.noheader = true
	  print cgi.header("type" => "text/html", "charset" => "utf-8")
	  print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head><title>debug message</title></head>
<body>
  <center>
    #{e1}<br>
    #{e2}<br>
    #{e3}<br>
    #{e4}<br>
    #{e5}<br>
    #{e6}<br>
    <br>
  </center>
</body>
</html>
EOF
	  exit
	end

end

# module Suzaku end 
end
