# ----------------------------------------------------------------------------
# create_table.rb : テーブルを作成する
# ----------------------------------------------------------------------------

require 'mysql'
require 'constant'
require 'suzaku_lib'
include Suzaku

# 設定ファイルによる初期設定
f = ARGV.shift
cf = Config.new(f)

# 設定ファイルによる初期設定
host          = cf.parm["host"]
userid        = cf.parm["userid"]
password      = cf.parm["password"]
database      = cf.parm["database"]

# データベースのオープン
db = Mysql::new(host, userid, password, database)
db.query("SET NAMES utf8")

# SQL実行

#
# keyword
#
sql = <<__EOF__
CREATE TABLE keyword (
        keyword VARCHAR(128) NOT NULL DEFAULT '',
        url_id INT NOT NULL DEFAULT '0',
        score TINYINT UNSIGNED NOT NULL DEFAULT '1',
        count INT NOT NULL DEFAULT '1',
        PRIMARY KEY (keyword, url_id),
        INDEX urlid_idx (url_id)
) type=MyISAM
__EOF__
db.query(sql)

#
# url
#
sql = <<__EOF__
CREATE TABLE url (
        url_id INT NOT NULL AUTO_INCREMENT,
        url VARCHAR(250) NOT NULL,
        tree_level TINYINT UNSIGNED NOT NULL DEFAULT '1',
        top_url_id INT DEFAULT '-1',
        registed DATETIME NOT NULL,
        last_modified DATETIME NOT NULL,
        last_parsed DATETIME NOT NULL,
        response CHAR(3) DEFAULT '000',
        title TEXT,
        abstract TEXT,
        contents TEXT,
        sequence_id INT,
        PRIMARY KEY (url_id),
        UNIQUE INDEX url_idx (url),
        INDEX top_idx (top_url_id),
        INDEX sequense_id_idx (sequence_id)
) type=MyISAM
__EOF__
db.query(sql)

#
# information
#
sql = <<__EOF__
CREATE TABLE information (
  url_id INT NOT NULL,
  category CHAR(2) NOT NULL DEFAULT '99',
  name_kanji VARCHAR(120),
  name_kana VARCHAR(120),
  mail_address VARCHAR(80),
  comment TEXT,
  access TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (url_id)
) type=MyISAM
__EOF__
db.query(sql)

#
# regist
#
sql = <<__EOF__
CREATE TABLE regist (
  log_id INT NOT NULL AUTO_INCREMENT,
  url VARCHAR(250),
  mail_address VARCHAR(80),
  regist_time DATETIME NOT NULL,
  PRIMARY KEY (log_id)
) type=MyISAM
__EOF__
db.query(sql)

#
# searchlog
#
sql = <<__EOF__
CREATE TABLE searchlog (
        log_id INT NOT NULL AUTO_INCREMENT,
        start_time DATETIME NOT NULL,
        process_time float NOT NULL,
        keywords TEXT,
        PRIMARY KEY (log_id)
) type=MyISAM
__EOF__
db.query(sql)

# データベースのクローズ
db.close
